/*
 * Copyright (C) 2006 Andre Noll <maan@systemlinux.org>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 */

#include "config.h"
/*
 * handle blocking writes for the grab client fds.
 * pedantic: close fd if write would block.
 * sloopy: ignore write
 * aggressive: write anyway (default)
 */

enum {GRAB_PEDANTIC, GRAB_SLOPPY, GRAB_AGGRESSIVE};
struct grab_client {
	
	int fd;
	struct grab_client_args_info *conf;
	int mode;
	int error;
	int audio_format_num;
	struct filter_callback fcb;
	struct list_head node;
	int argc;
	char **argv;
};

int check_grab_client_args(struct grab_client *gc);

enum {
	AUDIO_FORMAT_MP3,
	AUDIO_FORMAT_OGG
};

#define AUDIO_FORMAT_ARRAY "mp3", "ogg", NULL
#define MAX_STREAM_SLOTS 5
__malloc struct grab_client *grab_client_new(int fd, int argc, char **argv, int *err);
void activate_inactive_grab_clients(int slot, int audio_format_num, struct list_head *filter_list);
void activate_grab_client(struct grab_client *gc, struct filter_node *fn);
void init_grabbing(void);
